#ifndef CLASSICGAME_H
#define CLASSICGAME_H

#include <map>

#include "game.h"
#include "classicactions.h"

class ClassicGame final : public Game
{
public:
    explicit ClassicGame();
    virtual ~ClassicGame() override = default;

    virtual void run() override;

    virtual void input(const sf::Event& event) override;
    virtual void update() override;
    virtual void draw(const sf::RenderWindow& window) const override;

private:
    std::map<sf::Keyboard::Key, Button> _keys_to_buttons;
    std::map<Button, Action> _buttons_to_pressed_actions;
    std::map<Button, Action> _buttons_to_released_actions;

    Action getActionKeyPressed(Button button) const;
    Action getActionKeyReleased(Button button) const;
};

#endif // CLASSICGAME_H
